## ubuntu-printing-app 0.1+17.04.20170401

=== CMakeLists.txt ===
set(APP_NAME ubuntu-printing-app)
set(APP_HARDCODE ubuntu-printing-app)
set(DESKTOP_FILE "${APP_NAME}.desktop")
set(ICON_FILE ubuntu-printing-app.svg)
set(MAIN_QML Main.qml)
set(RUNNER ${APP_HARDCODE})
set(SNAP_DESKTOP_FILE snap/gui/${DESKTOP_FILE})

# Set the path for the QML files and the backend
set(UBUNTU_PRINTING_APP_DATA_DIR "${CMAKE_INSTALL_DATADIR}/${APP_HARDCODE}/ubuntu-printing-app")
set(MODULE_PATH ${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}/${APP_HARDCODE})

# Set the exec path
if(SNAP_MODE)
  set(EXEC "APP_ID=${APP_HARDCODE} qmlscene $@ -I $SNAP/${MODULE_PATH} $SNAP/${CMAKE_INSTALL_PREFIX}/${UBUNTU_PRINTING_APP_DATA_DIR}/${MAIN_QML}")
  set(ICON "$SNAP/${CMAKE_INSTALL_PREFIX}/${UBUNTU_PRINTING_APP_DATA_DIR}/${ICON_FILE}")
else(SNAP_MODE)
  set(EXEC "APP_ID=${APP_HARDCODE} qmlscene $@ -I ${MODULE_PATH} ${CMAKE_INSTALL_PREFIX}/${UBUNTU_PRINTING_APP_DATA_DIR}/${MAIN_QML}")
  set(ICON ${CMAKE_INSTALL_PREFIX}/${UBUNTU_PRINTING_APP_DATA_DIR}/${ICON_FILE})
endif(SNAP_MODE)

add_subdirectory(backend)
add_subdirectory(components)
add_subdirectory(runner)
add_subdirectory(pages)

# Add tests
find_package(Qt5Test REQUIRED)
enable_testing()
add_subdirectory(tests)

# Install Main.qml and icon
install(FILES ${MAIN_QML} DESTINATION ${UBUNTU_PRINTING_APP_DATA_DIR})
install(FILES ${ICON_FILE} DESTINATION ${UBUNTU_PRINTING_APP_DATA_DIR})

# Install content-hub json
install(FILES "ubuntu-printing-app-content-hub.json"
    DESTINATION ${CMAKE_INSTALL_DATADIR}/content-hub/peers
    RENAME ${APP_HARDCODE})

# Install desktop file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DESKTOP_FILE}.in.in ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in)
intltool_merge_translations(
  "${DESKTOP_FILE}.in"
  "${DESKTOP_FILE}"
  ALL
  UTF8
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)


# Show in QtCreator
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
  file(GLOB MAIN_QML_JS_FILES *.apparmor *.js *.json *.qml)
  add_custom_target(ubuntu_printing_app_main_qml_js_files ALL SOURCES ${MAIN_QML_JS_FILES})
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

# Set variables for use in parent scope
set(UBUNTU_PRINTING_APP_DESKTOP_FILE "${DESKTOP_FILE}" PARENT_SCOPE)

=== backend/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    /usr/include/poppler/qt5/
)

set(LIBNAME UbuntuPrintingAppbackend)

set(
  UbuntuPrintingAppSRC
  UbuntuPrintingApp/backend.cpp
  UbuntuPrintingApp/document.cpp
  UbuntuPrintingApp/popplerimageprovider.cpp
  UbuntuPrintingApp/pagehelper.cpp
)

add_library(${LIBNAME} SHARED ${UbuntuPrintingAppSRC})

qt5_use_modules(${LIBNAME} Core Gui Qml Quick)
target_link_libraries(${LIBNAME}
    poppler-qt5
)

set_target_properties(${LIBNAME} PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY UbuntuPrintingApp
)

# Copy the qmldir file to the build dir
add_custom_target(UbuntuPrintingApp_qmldir ALL
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/UbuntuPrintingApp/qmldir ${CMAKE_CURRENT_BINARY_DIR}/UbuntuPrintingApp
  DEPENDS ${QMLFILES})

# Install the plugin file
install(TARGETS ${LIBNAME} DESTINATION ${MODULE_PATH}/UbuntuPrintingApp)
install(FILES UbuntuPrintingApp/qmldir DESTINATION ${MODULE_PATH}/UbuntuPrintingApp)

=== components/CMakeLists.txt ===
set(COMPONENT_QML_JS_FILES
    AlertDialog.qml
    BaseRowLayout.qml
    CheckBoxRow.qml
    LabelRow.qml
    PreviewRow.qml
    PrintRow.qml
    PrintingHelper.qml
    SelectorRow.qml
    TextFieldRow.qml
)

install(FILES ${COMPONENT_QML_JS_FILES} DESTINATION ${UBUNTU_PRINTING_APP_DATA_DIR}/components)

# Show in QtCreator
add_custom_target(ubuntu_printing_app_components_qml_js_files ALL SOURCES ${COMPONENT_QML_JS_FILES})

=== pages/CMakeLists.txt ===
set(PAGES_QML_JS_FILES
    ContentPeerPickerPage.qml
    EmptyPage.qml
    PrintPage.qml
)

install(FILES ${PAGES_QML_JS_FILES} DESTINATION ${UBUNTU_PRINTING_APP_DATA_DIR}/pages)

# Show in QtCreator
add_custom_target(ubuntu_printing_app_pages_qml_js_files ALL SOURCES ${PAGES_QML_JS_FILES})

=== runner/CMakeLists.txt ===

# Install runner
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${RUNNER}.in ${CMAKE_CURRENT_BINARY_DIR}/${RUNNER})

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${RUNNER} DESTINATION ${CMAKE_INSTALL_BINDIR})


# Show in QtC
add_custom_target(ubuntu_printing_app_runner_files ALL SOURCES ${RUNNER}.in)

=== src/CMakeLists.txt ===
add_definitions(
  -DGETTEXT_PACKAGE=\"${PROJECT_NAME}\"
  -DGETTEXT_LOCALEDIR=\"${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LOCALEDIR}\"
  -DG_LOG_DOMAIN=\"${CMAKE_PROJECT_NAME}\"
)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${SERVICE_DEPS_INCLUDE_DIRS}
)
link_directories(
  ${SERVICE_DEPS_LIBRARY_DIRS}
)

find_package(GDbus REQUIRED)
add_gdbus_codegen(
  SERVICE_GENERATED_SOURCES
  cups-cupsd-notifier
  org.cups.cupsd
  ${CMAKE_CURRENT_SOURCE_DIR}/org.cups.cupsd.Notifier.xml)

add_library(${SERVICE_LIB_NAME} STATIC
  actions.cpp
  actions.h
  client.h
  cups-client.cpp
  cups-client.h
  job.h
  notification.cpp
  notification.h
  notify-engine.cpp
  notify-engine.h
  printer.h
  utils.cpp
  utils.h
  ${SERVICE_GENERATED_SOURCES}
)

target_link_libraries(${SERVICE_LIB_NAME}
  ${SERVICE_DEPS_LIBRARIES}
  ${CUPS_LIBS}
)


add_executable(${SERVICE_EXEC_NAME}
  main.cpp
)

target_link_libraries(${SERVICE_EXEC_NAME}
  ${SERVICE_LIB_NAME}
  ${SERVICE_DEPS_LIBRARIES}
  ${CUPS_LIBS}

  ${CMAKE_THREAD_LIBS_INIT}
)

install(
  TARGETS ${SERVICE_EXEC_NAME}
  RUNTIME
  DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/${PROJECT_NAME}
)

=== tests/qmltests/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)
find_package(Qt5QuickTest REQUIRED)

find_program(XVFBRUN xvfb-run)
if(NOT XVFBRUN)
  message(FATAL_ERROR "Could not find xvfb-run, please install the xvfb package")
endif()
set(XVFB_COMMAND ${XVFBRUN} -s "-screen 0 640x480x24" -a)

find_program(QMLTESTRUNNER qmltestrunner)
if(NOT QMLTESTRUNNER)
    message(FATAL_ERROR "Could not find qmltestrunner, please install the package qtdeclarative5-dev-tools")
endif()

set(TEST tst_QmlTests)
add_test(${TEST} ${XVFB_COMMAND} ${QMLTESTRUNNER} -qt=qt5
         -input ${CMAKE_CURRENT_SOURCE_DIR}
         -import ${CMAKE_BINARY_DIR}/ubuntu-printing-app/backend)


# Add the qml test files to build dir
set(QMLTEST_FILES
    tst_CheckBoxRow.qml
    tst_LabelRow.qml
    tst_PreviewRow.qml
    tst_PrintRow.qml
    tst_PrintPage.qml
    tst_SelectorRow.qml
    tst_TextFieldRow.qml
)

add_custom_target(qmltest_copyFiles ALL
  COMMENT "Copying files: ${QMLTEST_FILES}")

foreach(FILENAME ${QMLTEST_FILES})
  add_custom_command(
    TARGET qmltest_copyFiles
    COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME}" "${CMAKE_CURRENT_BINARY_DIR}/${FILENAME}"
    )
endforeach(FILENAME)

# Show in QtC
add_custom_target(qmltest_files ALL SOURCES ${QMLTEST_FILES})

=== tests/unittests/backend/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/ubuntu-printing-app/backend/
)

find_package(Qt5Test REQUIRED)

add_executable(testDocument tst_document.cpp ${PDF_TEST_FILES})
target_link_libraries(testDocument UbuntuPrintingAppbackend Qt5::Test Qt5::Gui)
add_test(tst_document testDocument)

add_executable(testPageHelper tst_pagehelper.cpp ${PDF_TEST_FILES})
target_link_libraries(testPageHelper UbuntuPrintingAppbackend Qt5::Test Qt5::Gui)
add_test(tst_pagehelper testPageHelper)

add_executable(testPopplerImageProvider tst_popplerimageprovider.cpp ${PDF_TEST_FILES})
target_link_libraries(testPopplerImageProvider UbuntuPrintingAppbackend Qt5::Test Qt5::Gui)
add_test(tst_popplerimageprovider testPopplerImageProvider)

=== debian/changelog ===
ubuntu-printing-app (0.1+17.04.20170401-0ubuntu1) zesty; urgency=medium

  * Change qtdeclarative5-ubuntu-ui-toolkit-plugin to qml-module-ubuntu-
    components in depends (and -gles) (LP: #1673808)
  * Add qmlscene to depends
  * Only show Print Queue in Unity8

 -- Andrew Hayzen <ahayzen@gmail.com>  Sat, 01 Apr 2017 17:51:04 +0000

ubuntu-printing-app (0.1+17.04.20170323-0ubuntu1) zesty; urgency=medium

  [ Andrew Hayzen ]
  * Fix typo in copyright
  * Move printing app tests into the ubuntu-printing-app folder
  * Add queue dialog with relevant components
  * Only show sheets count in print button when we are not performing a
    print range for now.
  * Fix notifier system-settings url

  [ Rodney Dawes ]
  * Add notifier daemon.
  * Use intltool module from cmake-extras and update template.

 -- Andrew Hayzen <ahayzen@gmail.com>  Thu, 23 Mar 2017 12:38:48 +0000

ubuntu-printing-app (0.1+17.04.20170317-0ubuntu1) zesty; urgency=medium

  * Replace GPL-3.0+ with GPL-3

 -- Andrew Hayzen <ahayzen@gmail.com>  Fri, 17 Mar 2017 14:07:17 +0000

ubuntu-printing-app (0.1+17.04.20170308-0ubuntu1) zesty; urgency=medium

  * Initial release
  * Empty commit for bileto
  * Set max width of options

 -- Andrew Hayzen <ahayzen@gmail.com>  Wed, 08 Mar 2017 13:03:52 +0000

=== debian/control ===
Source: ubuntu-printing-app
Section: misc
Priority: optional
Maintainer: Andrew Hayzen <andrew.hayzen@canonical.com>
Build-Depends: cmake (>= 2.8.9),
               cmake-extras (>= 0.10),
               cmake-extras (>= 1.3),
               debhelper (>=9),
               dh-apparmor,
               dh-translations,
               gcovr,
               googletest | google-mock,
               intltool,
               lcov,
               libboost-dev,
               libcups2-dev,
               libglib2.0-dev (>= 2.35.4),
               libnotify-dev,
               libpoppler-qt5-dev,
               libproperties-cpp-dev,
               liburl-dispatcher1-dev,
               qmlscene,
               qml-module-qtquick2,
               qml-module-qtquick-layouts,
               qml-module-qttest,
               qml-module-ubuntu-components (>= 1.3) | qml-module-ubuntu-components-gles (>= 1.3),
               qml-module-ubuntu-test,
               qtdeclarative5-ubuntu-content1,
               qtdeclarative5-ubuntu-ui-extras0.2,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               xvfb
Standards-Version: 3.9.7
Homepage: http://launchpad.net/ubuntu-printing-app
Vcs-Bzr: https://code.launchpad.net/~phablet-team/ubuntu-printing-app/trunk

Package: ubuntu-printing-app
Architecture: any
Depends: qml-module-qtquick2,
         qml-module-qtquick-layouts,
         qmlscene,
         qml-module-ubuntu-components (>= 1.3) | qml-module-ubuntu-components-gles (>= 1.3),
         qtdeclarative5-ubuntu-content1,
         qtdeclarative5-ubuntu-ui-extras0.2,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Printing app which consumes a PDF from content-hub
 Printing app which consumes a PDF document from
 content-hub, allows for basic configuration and
 then sends to a CUPS printer.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@ 

override_dh_install:
	dh_install --fail-missing
	dh_apparmor -pubuntu-printing-app --profile-name=usr.bin.ubuntu-printing-app
